(* Delphi-Programm
   Astronomische Berechnungen fr Sonne und Mond
   =============================================

    Dr. J. Rathlev, D-24222 Schwentinental (kontakt(a)rathlev-home.de)

   The contents of this file may be used under the terms of the
   Mozilla Public License ("MPL") or
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.

   Version 1: July 2019
   *)

unit SmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, NumberEd, Vcl.ComCtrls,
  Vcl.Buttons, SunMoon, Vcl.ExtCtrls, System.ImageList, Vcl.ImgList;

const
  Prog = 'Berechnungen um Sonne und Mond';
  Vers = 'Version 1.0';
  CopRgt = ' 2019 - Dr. J. Rathlev, D-24222 Schwentinental';
  EMailAdr = 'kontakt(a)rathlev-home.de';

type
  TfrmSmMain = class(TForm)
    gbInput: TGroupBox;
    gbSun: TGroupBox;
    gbMoon: TGroupBox;
    dcbLat: TDegreeComboBox;
    dcbLon: TDegreeComboBox;
    Label1: TLabel;
    Label2: TLabel;
    dtDate: TDateTimePicker;
    dtTime: TDateTimePicker;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    cxTimeZone: TComboBox;
    edDeltaT: TFloatEdit;
    Label13: TLabel;
    cbDaylightSaving: TCheckBox;
    gbCommon: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    edJD: TFloatEdit;
    edGMST: TEdit;
    edLMST: TEdit;
    btToday: TBitBtn;
    btnCalc: TBitBtn;
    edHeight: TFloatEdit;
    Label9: TLabel;
    Label10: TLabel;
    edSunrise: TEdit;
    Label11: TLabel;
    edSunTransit: TEdit;
    Label12: TLabel;
    edSunset: TEdit;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    edSunDist: TFloatEdit;
    edSunObsDist: TFloatEdit;
    Label18: TLabel;
    Label19: TLabel;
    gbSunDist: TGroupBox;
    gbSunPos: TGroupBox;
    Label15: TLabel;
    edSunAzimut: TFloatEdit;
    Label20: TLabel;
    edSunDekl: TFloatEdit;
    edSunElev: TFloatEdit;
    Label21: TLabel;
    Label22: TLabel;
    btDeltaT: TBitBtn;
    Label23: TLabel;
    Label24: TLabel;
    gbTimes: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    edEquOfTm: TFloatEdit;
    gbTwilight: TGroupBox;
    pcTwilight: TPageControl;
    tsCivil: TTabSheet;
    tsNautical: TTabSheet;
    tsAstro: TTabSheet;
    cbTwilight: TComboBox;
    Label27: TLabel;
    edCivilTwilightMorning: TEdit;
    Label28: TLabel;
    edCivilTwilightEvening: TEdit;
    Label29: TLabel;
    edAstronomicalTwilightMorning: TEdit;
    Label30: TLabel;
    edAstronomicalTwilightEvening: TEdit;
    Label31: TLabel;
    edNauticalTwilightMorning: TEdit;
    Label32: TLabel;
    edNauticalTwilightEvening: TEdit;
    Label33: TLabel;
    edSunDiameter: TFloatEdit;
    Label34: TLabel;
    edSunRekt: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    edSunEklLon: TFloatEdit;
    Label38: TLabel;
    edSunSign: TEdit;
    Label39: TLabel;
    GroupBox1: TGroupBox;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    edMoonDist: TFloatEdit;
    edMoonObsDist: TFloatEdit;
    gbMoonPos: TGroupBox;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    edMoonAzimut: TFloatEdit;
    edMoonDekl: TFloatEdit;
    edMoonElev: TFloatEdit;
    edMoonDiameter: TFloatEdit;
    edMoonRekt: TEdit;
    edMoonEklLat: TFloatEdit;
    edMoonPhase: TEdit;
    GroupBox3: TGroupBox;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    edMoonrise: TEdit;
    edMoonset: TEdit;
    edMoonTransit: TEdit;
    Label60: TLabel;
    Label61: TLabel;
    edMoonEklLon: TFloatEdit;
    Label62: TLabel;
    edMoonSign: TEdit;
    imgSunSign: TImage;
    ilStarSigns: TImageList;
    imgMoonSign: TImage;
    btSavePos: TBitBtn;
    cbPosList: TComboBox;
    paCommon: TPanel;
    btRemPos: TBitBtn;
    btExit: TBitBtn;
    BitBtn1: TBitBtn;
    ilMoonPhases: TImageList;
    imgMoonPhase: TImage;
    Label63: TLabel;
    Label64: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnCalcClick(Sender: TObject);
    procedure btTodayClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btDeltaTClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbTwilightChange(Sender: TObject);
    procedure dcbLatCloseUp(Sender: TObject);
    procedure dcbLonCloseUp(Sender: TObject);
    procedure btSavePosClick(Sender: TObject);
    procedure cbPosListDropDown(Sender: TObject);
    procedure cbPosListCloseUp(Sender: TObject);
    procedure btRemPosClick(Sender: TObject);
    procedure btExitClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    IniName,
    PrgName,
    ProgVersName,
    ProgVersDate   : string;
    smData : TSunMoonData;
  public
    { Public-Deklarationen }
  end;

var
  frmSmMain: TfrmSmMain;

implementation

{$R *.dfm}

uses System.IniFiles, System.DateUtils, Winapi.ShlObj, InpText, EditStringListDlg,
  WinUtils, StringUtils, NumberUtils, WinShell, FileUtils;

type
  TTimeZone = record
    Offset : integer;
    ZoneName, Regions : string;
    end;

  TPosData = class (TObject)
    Lat,Lon,Hgt  : double;
    constructor Create (ALat,ALon,AHgt : double);
    end;

const
  ZeitZonen : array [-11..12] of TTimeZone =
           ((Offset : -11; ZoneName : 'UTC-11'; Regions : 'Midwayinseln'),
            (Offset : -10; ZoneName : 'Hawaii Std. Time (HST)'; Regions : 'Honolulu'),
            (Offset :  -9; ZoneName : 'Alaska Std. Time (AKST)'; Regions : 'Anchorage'),
            (Offset :  -8; ZoneName : 'Pacific Std. Time (PST)'; Regions : 'Vancouver, Los Angeles'),
            (Offset :  -7; ZoneName : 'Mountain Std. Time (MST)'; Regions : 'Edmonton, Denver'),
            (Offset :  -6; ZoneName : 'Central Std. Time (CST)'; Regions : 'Winnipeg, Chicago, Dallas, Mexico'),
            (Offset :  -5; ZoneName : 'Eastern Std. Time (EST)'; Regions : 'Toronto, New York, Lima'),
            (Offset :  -4; ZoneName : 'Atlantic Std. Time (AST)'; Regions : 'Halifax, La Paz, Santiago'),
            (Offset :  -3; ZoneName : 'Brasilia Time (BRT)'; Regions : 'Grnland, Rio de Janeiro, Buenos Aires'),
            (Offset :  -2; ZoneName : 'Fernando de Noronha Time (FNT)'; Regions : 'Sg Georgien'),
            (Offset :  -1; ZoneName : 'Azores Time (AZOT)'; Regions : 'Azoren'),
            (Offset :   0; ZoneName : 'Westeurop. Zeit (WEZ)'; Regions : 'Island, London, Lissabon, Westafrika'),
            (Offset :  +1; ZoneName : 'Mitteleurop. Zeit (MEZ)'; Regions : 'Paris, Berlin, Rom, Algerien, Zentralafrika'),
            (Offset :  +2; ZoneName : 'Osteurop. Zeit (EEZ)'; Regions : 'Helsinki, Kiew, Athen, Istanbul, Sd-Afrika'),
            (Offset :  +3; ZoneName : 'Moskauer Zeit (MSK)'; Regions : 'Moskau, Saudi-Arabien, Kenia'),
            (Offset :  +4; ZoneName : 'Samara Time (SAMT)'; Regions : 'Georgien, Oman'),
            (Offset :  +5; ZoneName : 'Pakistan Time (PKT)'; Regions : 'Perm, Islamabad'),
            (Offset :  +6; ZoneName : 'Novosibirsk Time (NOVT)'; Regions : 'Omsk, Kasakstan, Indien(-0,5)'),
            (Offset :  +7; ZoneName : 'Indochina Time (ICT)'; Regions : 'Thailand, Vietnam'),
            (Offset :  +8; ZoneName : 'China Std. Time (CST)'; Regions : 'Peking, Malaysia, Perth'),
            (Offset :  +9; ZoneName : 'Japan Std. Time (JST)'; Regions : 'Yakutsk, Tokio'),
            (Offset : +10; ZoneName : 'East Austr. Time, (AET)'; Regions : 'Wladiwostok, Sydney'),
            (Offset : +11; ZoneName : 'Magadan Time (MAGT)'; Regions : 'Kamtschatka'),
            (Offset : +12; ZoneName : 'New Zealand Std. Time (NZST)'; Regions : 'Marshall-Inseln, Wellington  '));

  MoonPhases : array [TLunarPhase] of string = (
    'Neumond', 'Zunehmende Sichel', 'Zunehmender Halbmond', 'Zunehmender Mond',
    'Vollmond', 'Abnehmender Mond', 'Abnehmender Halbmond', 'Abnehmende Sichel');

  StarSigns : array [TStarSign] of string = (
    'Widder','Stier','Zwillinge','Krebs','Lwe','Jungfrau','Waage','Skorpion',
    'Schtze','Steinbock','Wassermann','Fische');

  MaxHist = 20;
  MaxLocs = 50;

  IniExt = 'ini';

  (* INI-Sektionen *)
  CfGSekt = 'Config';
  LatSekt = 'Latitudes';
  LonSekt = 'Longitudes';
  LocSekt = 'Locations';

  iniTop  = 'Top';
  iniLeft = 'Left';
  iniLat  = 'Latitidue';
  iniLon  = 'Longitude';
  iniHgt  = 'Height';
  iniDt   = 'DeltaT';
  iniTz   = 'TimeZone';
  iniDs   = 'DaylightSaving';
  iniLCnt = 'LocCount';
  iniVal  = 'Value';

constructor TPosData.Create (ALat,ALon,AHgt : double);
begin
  inherited Create;
  Lat:=ALat; Lon:=ALon; Hgt:=AHgt;
  end;

procedure TfrmSmMain.FormCreate(Sender: TObject);
var
  i,n : integer;
  s,sloc,sv : string;
  xlat,xlon,xhgt : extended;
  ok             : boolean;
  IniFile  : TIniFile;

  function TimeZoneStr(n : integer) : string;
  begin
    if n<0 then Result:='-' else if n>0 then Result:='+' else Result:=#$b1;
    Result:=ZeitZonen[n].ZoneName+' ('+Result+IntToStr(abs(n))+')';
    end;

begin
  PrgName:=ExtractFileName(DelExt(Application.ExeName));
  ProgVersName:=Prog;
  ProgVersDate:=Vers+' v. '+DateToStr(FileDateToDateTime(FileAge(Application.ExeName)));
  smData:=InitData;
  with smData do begin
    dcbLat.Value:=Lat; dcbLon.Value:=Lon;
    edDeltaT.Value:=round(DeltaT);
    dtDate.Date:=Today; dtTime.Time:=Time;
    end;
  with cxTimeZone do begin
    for i:=-11 to 12 do Items.Add(TimeZoneStr(i));
    ItemIndex:=12;
    end;
  IniName:=Erweiter(GetDesktopFolder(CSIDL_APPDATA),PrgName,IniExt);
  IniFile:=TIniFile.Create(IniName);
  with IniFile do begin
    Top:=ReadInteger (CfgSekt,iniTop,Top);
    Left:=ReadInteger (CfgSekt,iniLeft,Left);
    with dcbLat do Value:=ReadFloat(CfgSekt,iniLat,Value);
    with dcbLon do Value:=ReadFloat(CfgSekt,iniLon,Value);
    with edHeight do Value:=ReadFloat(CfgSekt,iniHgt,Value);
    with edDeltaT do Value:=ReadFloat(CfgSekt,iniDt,Value);
    with cxTimeZone do ItemIndex:=ReadInteger(CfgSekt,iniTz,ItemIndex-11)+11;
    cbDaylightSaving.Checked:=ReadBool(CfgSekt,iniDs,false);
    n:=ReadInteger(CfgSekt,iniLCnt,0);
    for i:=0 to n-1 do begin
      s:=ReadString(LocSekt,iniVal+IntToStr(i),'');
      if length(s)>0 then begin
        sloc:=ReadNxtStr(s,'|');
        ok:=length(sloc)>0;
        sv:=ReadNxtStr(s,'|');
        ok:=ok and StrToDeg(sv,xLat);
        sv:=ReadNxtStr(s,'|');
        ok:=ok and StrToDeg(sv,xLon);
        sv:=ReadNxtStr(s,'|');
        ok:=ok and TryStrToFloat(sv,xHgt);
        if ok then cbPosList.AddItem(sloc,TPosData.Create(xlat,xlon,xhgt));
        end;
      end;
    end;
  LoadHistory(IniFile,LatSekt,iniVal,dcbLat.Items,MaxHist);
  LoadHistory(IniFile,LonSekt,iniVal,dcbLon.Items,MaxHist);
  IniFile.Free;
  end;

procedure TfrmSmMain.FormDestroy(Sender: TObject);
var
  IniFile  : TIniFile;
  i        : integer;

  function GetPosStr(PosData : TPosData) : string;
  begin
    with PosData do
      Result:=dcbLat.ValToStr(Lat)+'|'+dcbLon.ValToStr(Lon)+'|'+FloatToStrF(Hgt,ffFixed,5,1)
    end;

begin
  IniFile:=TIniFile.Create(IniName);
  with IniFile do begin
    WriteInteger (CfgSekt,iniTop,Top);
    WriteInteger (CfgSekt,iniLeft,Left);
    WriteFloat(CfgSekt,iniLat,dcbLat.Value);
    WriteFloat(CfgSekt,iniLon,dcbLon.Value);
    WriteFloat(CfgSekt,iniHgt,edHeight.Value);
    WriteFloat(CfgSekt,iniDt,edDeltaT.Value);
    WriteInteger(CfgSekt,iniTz,cxTimeZone.ItemIndex-11);
    WriteBool(CfgSekt,iniDs,cbDaylightSaving.Checked);
    EraseSection (LocSekt);
    with cbPosList.Items do begin
      WriteInteger(CfgSekt,iniLCnt,Count);
      for i:=0 to Count-1 do
        WriteString(LocSekt,iniVal+IntToStr(i),Strings[i]+'|'+GetPosStr(TPosData(Objects[i])));
      end;
    end;
  SaveHistory(IniFile,LatSekt,iniVal,true,dcbLat.Items,MaxHist);
  SaveHistory(IniFile,LonSekt,iniVal,true,dcbLon.Items,MaxHist);
  FreeListObjects(cbPosList.Items);
  IniFile.Free;
  end;

procedure TfrmSmMain.FormShow(Sender: TObject);
begin
  pcTwilight.ActivePageIndex:=0;
  btnCalcClick(Sender);
  end;

procedure TfrmSmMain.btTodayClick(Sender: TObject);
begin
  dtDate.Date:=Today; dtTime.Time:=Time;
  btnCalcClick(Sender);
  end;

procedure TfrmSmMain.cbTwilightChange(Sender: TObject);
begin
  case cbTwilight.ItemIndex of
  1 : pcTwilight.ActivePageIndex:=1;
  2 : pcTwilight.ActivePageIndex:=2;
  else pcTwilight.ActivePageIndex:=0;
    end;
  end;

procedure TfrmSmMain.dcbLatCloseUp(Sender: TObject);
begin
  with dcbLat do Value:=Values[ItemIndex];
  end;

procedure TfrmSmMain.dcbLonCloseUp(Sender: TObject);
begin
  with dcbLon do Value:=Values[ItemIndex];
  end;

procedure TfrmSmMain.BitBtn1Click(Sender: TObject);
begin
  InfoDialog (ProgVersName+' - '+ProgVersDate+sLineBreak+
    CopRgt+sLineBreak+'E-Mail: '+EMailAdr+sLineBreak+
    'Die astronomischen Berechnungen basieren auf meiner Delphi-Umsetzung'+sLineBreak+
    'eines Javascripts von Arnold Barmettler (www.astronomie.info/www.CalSky.com)'+sLineBreak+
    'und den Algorithmen von Peter Duffett-Smith: "Practical Astronomy with your Calculator"');
  end;

procedure TfrmSmMain.btDeltaTClick(Sender: TObject);
begin
  edDeltaT.Value:=InitData.DeltaT;
  end;

procedure TfrmSmMain.btExitClick(Sender: TObject);
begin
  Close;
  end;

procedure TfrmSmMain.btnCalcClick(Sender: TObject);
var
  d : integer;
  tm : TDateTime;
begin
  dcbLat.AddCurrentValue;
  dcbLon.AddCurrentValue;
  d:=cxTimeZone.ItemIndex-11;
  if cbDaylightSaving.Checked then inc(d);
  tm:=TimeOf(dtTime.Time);
  tm:=DateOf(dtDate.Date)+(HourOf(tm)+MinuteOf(tm)/60)/24;
  smData:=ComputeSunMoon(dcbLat.Value,dcbLon.Value,edHeight.Value,tm,edDeltaT.Value,d);
  with smData do begin
    edJD.Value:=JD;
    edGMST.Text:=TimeOfDayToStr(GMST);
    edLMST.Text:=TimeOfDayToStr(LMST);
    edEquOfTm.Value:=EOT;
    edSunrise.Text:=TimeOfDayToStr(SunRise,true);
    edSunTransit.Text:=TimeOfDayToStr(SunTransit,false);
    edSunset.Text:=TimeOfDayToStr(SunSet,true);
    edSunDist.Value:=SunDistance;
    edSunObsDist.Value:=SunDistanceObserver;
    edSunAzimut.Value:=SunAz;
    edSunElev.Value:=SunAlt;
    edSunDekl.Value:=SunDec;
    edSunEklLon.Value:=SunLon;
    edSunRekt.Text:=TimeOfDayToStr(SunRA,true);
    edSunDiameter.Value:=SunDiameter;
    edSunSign.Text:=StarSigns[SunSign];
    edCivilTwilightMorning.Text:=TimeOfDayToStr(SunCivilTwilightMorning,true);
    edCivilTwilightEvening.Text:=TimeOfDayToStr(SunCivilTwilightEvening,true);
    edNauticalTwilightMorning.Text:=TimeOfDayToStr(SunNauticalTwilightMorning,true);
    edNauticalTwilightEvening.Text:=TimeOfDayToStr(SunNauticalTwilightEvening,true);
    edAstronomicalTwilightMorning.Text:=TimeOfDayToStr(SunAstronomicalTwilightMorning,true);
    edAstronomicalTwilightEvening.Text:=TimeOfDayToStr(SunAstronomicalTwilightEvening,true);
    edMoonRise.Text:=TimeOfDayToStr(MoonRise,true);
    edMoonTransit.Text:=TimeOfDayToStr(MoonTransit,false);
    edMoonset.Text:=TimeOfDayToStr(MoonSet,true);
    edMoonDist.Value:=MoonDistance;
    edMoonObsDist.Value:=MoonDistanceObserver;
    edMoonAzimut.Value:=MoonAz;
    edMoonElev.Value:=MoonAlt;
    edMoonDekl.Value:=MoonDec;
    edMoonEklLat.Value:=MoonLat;
    edMoonEklLon.Value:=MoonLon;
    edMoonRekt.Text:=TimeOfDayToStr(MoonRA,true);
    edMoonDiameter.Value:=MoonDiameter;
    edMoonPhase.Text:=MoonPhases[MoonPhase];
    edMoonSign.Text:=StarSigns[MoonSign];
    with imgSunSign do begin
      Picture:=nil;
      ilStarSigns.GetIcon(integer(SunSign),Picture.Icon);
      end;
    with imgMoonPhase do begin
      Picture:=nil;
      ilMoonPhases.GetIcon(integer(MoonPhase),Picture.Icon);
      end;
    with imgMoonSign do begin
      Picture:=nil;
      ilStarSigns.GetIcon(integer(MoonSign),Picture.Icon);
      end;
    end;
  end;


procedure TfrmSmMain.btRemPosClick(Sender: TObject);
var
  n : integer;
begin
  with cbPosList do begin
    EditStringList(BottomRightPos(btSavePos),'',Hint,Items,true,n);
    end;
  end;

procedure TfrmSmMain.btSavePosClick(Sender: TObject);
var
  s : string;
  n : integer;
begin
  s:='';
  If InputText(BottomRightPos(btSavePos),'Position speichern','Ortsname:',false,s) then begin
    with cbPosList do begin
      n:=Items.IndexOf(s);
      if (n>=0) then begin
        if ConfirmDialog(BottomRightPos(btSavePos),
          'Dieser Ort ist bereits gespeichert - berschreiben?') then with Items do begin
          Objects[n].Free; Delete(n);
          AddObject(s,TPosData.Create(dcbLat.Value,dcbLon.Value,edHeight.Value));
          end
        end
      else AddItem(s,TPosData.Create(dcbLat.Value,dcbLon.Value,edHeight.Value))
      end
    end;
  end;

procedure TfrmSmMain.cbPosListCloseUp(Sender: TObject);
begin
  with cbPosList do begin
    Left:=345; Width:=21;
    if ItemIndex>=0 then with TPosData(Items.Objects[ItemIndex]) do begin
      dcbLat.Value:=Lat; dcbLon.Value:=Lon; edHeight.Value:=Hgt;
      btnCalcClick(Sender);
      end;
    end;
  end;

procedure TfrmSmMain.cbPosListDropDown(Sender: TObject);
begin
  with cbPosList do begin
    Left:=245; Width:=121;
    end;
  end;

end.
